<?php

abstract class Limex_Advd_Block_Adminhtml_Widget_Abstract_Grid
    extends Limex_Advd_Block_Adminhtml_Widget_Abstract
{
    protected abstract function _prepareCollection($grid);
    protected abstract function _prepareColumns($grid);

    public function _prepareLayout()
    {
        $this->setTemplate('mst_advd/widget/grid.phtml');

        return parent::_prepareLayout();
    }

    public function getGridHtml()
    {
        $grid = $this->getLayout()->createBlock('advd/adminhtml_widget_abstract_adminhtml_grid');

        $this->_prepareCollection($grid);
        $this->_prepareColumns($grid);

        if (method_exists($this, 'getRowUrl')) {
            $grid->setRowUrlCallback(array($this, 'getRowUrl'));
        }

        return $grid->toHtml();
    }

}